unit MainClient;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, PicoScope9000_TLB;


type
  TMyControl = class(TCustomControl)
  public
    property canvas;
  end;  


type
  TClientsForm = class(TForm)
    btnConnect: TButton;
    btnDisconnect: TButton;
    Memo1: TMemo;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    btnSend: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnDisconnectClick(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
   private
    { Private declarations }
    FUDS_RC: ICOMRC;
    FDelay: Byte;
    Image1: TMyControl;
  public
    { Public declarations }
    procedure ChangeEnablity(en: Boolean);
    procedure DrawCurve(const Answ: AnsiString);
    procedure ClrImage;
  end;

var
  ClientsForm: TClientsForm;
  jjj: LongInt;

implementation

{$R *.dfm}






{ TForm1 }

procedure TClientsForm.ChangeEnablity(en: Boolean);
var
  col: TColor;
begin
  if en then col := clGreen
  else       col := clRed;
  Panel1.Color := col;
  btnConnect.Enabled := not en;
  btnDisconnect.Enabled := en;
  btnSend.Enabled := en;
  ComboBox1.Enabled := en;
  Memo1.Enabled := en;
end;

procedure TClientsForm.FormCreate(Sender: TObject);
begin
  ChangeEnablity(false);
  
end;

procedure TClientsForm.btnDisconnectClick(Sender: TObject);
begin
  FUDS_RC := nil;
  ChangeEnablity(false);
end;

procedure TClientsForm.btnConnectClick(Sender: TObject);
begin
  FUDS_RC := CoCOMRC.Create;
  ChangeEnablity(true);
end;

procedure TClientsForm.btnSendClick(Sender: TObject);
var
  Ansver: AnsiString;
  la: Word;
  lm: Word;
  iii: integer;

  function GetMemoBytes: Word;
  var
    i: Word;
  begin
    result := 0;
    for i := 0 to Memo1.Lines.Count - 1 do
      Inc(result, Length(Memo1.Lines[i]))
  end;

  procedure ClearFirstNChar(n: Word);
  begin
    Memo1.SelStart := 0;
    Memo1.SelLength := n;
    Memo1.ClearSelection
  end;

begin
  if ComboBox1.Text <> '' then
    begin
      if ComboBox1.Items.IndexOf(ComboBox1.Text) = -1 then
        ComboBox1.Items.Add(ComboBox1.Text);
      if ComboBox1.Items.Count > 100 then
        ComboBox1.Items.Delete(0);

//      Ansver := AnsiString(FUDS_RC.ExecCommand(ComboBox1.Text));
//      Ansver := Spider.ExecuteStringOfCommands(ComboBox1.Text);

      if Trim(UpperCase(ComboBox1.Text)) = 'WFM:DATA?' then
      begin
        Label1.Caption:=   DateTimeToStr(now);
        //Timer1.Enabled:=True;
        for iii:=1 to 1000 do begin
            Ansver := AnsiString(FUDS_RC.ExecCommand(ComboBox1.Text));
            DrawCurve(Ansver);

        end;
        Label2.Caption:=   DateTimeToStr(now);
      end;

      if FDelay > 0 then
        begin
          Dec(FDelay);
          if FDelay = 0 then
            ClrImage
        end;


      if (Ansver <> '') and (Ansver <> ' ') then
        begin
          if Length(Ansver) > 25000 then
            begin
              delete(Ansver, 25001, Length(Ansver) - 25000);
              Ansver := Ansver + ' . . . . . . .';
            end;
          la := Length(Ansver);
          lm := GetMemoBytes;
          if la + lm > 30000 then
            ClearFirstNChar(la + lm - 28000);
          Memo1.Lines.Add(String('--> ' + Ansver));
//          Memo1.Lines.Add('___________________'#13#10)
        end
    end;

//var
//  s: String;
//begin
//  s := FUDS_RC.ExecCommand(Edit1.Text);
//  Memo1.Lines.Add(s)
end;

procedure TClientsForm.ClrImage;
begin
  Image1.Free;
  Image1 := Nil
end;

procedure TClientsForm.DrawCurve(const Answ: AnsiString);
var
  Num, i, p: Word;
  s: AnsiString;
  s2: String[20];
  v: Double;
  min, max: Double;
  MM: Array[1..4096] of double;
  OldDECIMALSEPARATOR: Char;
  x: Word;
  y: Word;
  a: Double;
  mid: Double;
begin
  if pos('SIGNAL IS ABSENT', string(Answ)) <> 0 then
    ClrImage
  else
    begin
      if Assigned(Image1) then
        Image1.Free;
      Image1 := TMyControl.Create(self);
      Image1.Parent := self;
      Image1.Width  := self.ClientWidth;
      Image1.Left   := 0;
      Image1.Top    := self.ClientHeight-64;
      Image1.Height := 64;

      Image1.Canvas.Brush.Color := clBlack;
      Image1.Canvas.FillRect(Rect(0, 0, Image1.Width, 64));
      OldDECIMALSEPARATOR := DECIMALSEPARATOR;
      DECIMALSEPARATOR    := '.';
      s := Answ;

      p := pos(' ', string(s));
      if p <> pos(', ', string(s)) then  //Ubiraem Header
        Delete(s, 1, p);

      Num := 0;
      min := 1e133; max := -1e133;
      repeat
        p := pos(', ', string(s));
        if p = 0 then
          s2 := s
        else
          begin
            s2 := copy(s, 1, p-1);
            delete(s, 1, p+1)
          end;
        inc(Num);
        v := StrToFloat(string(s2));
        MM[Num] := v;
        if v < min then min := v;
        if v > max then max := v
      until p = 0;

      DECIMALSEPARATOR := OldDECIMALSEPARATOR;

//      x   := 0;
//      kx  := 256 / Num;
      a   := (max - min) / 2;  // Amplituda
      if a = 0 then a := 1;

      mid := (max + min) / 2;  // Srednee

      for i := 1 to Num do
        begin
//          x := Trunc((i-1)*kx);
          x := i-1;
          y := 32 - Round(32 * (MM[i] - mid) / a);
          Image1.Canvas.Pixels[x,y] := clWhite
        end;
    //  y01: Double;

      FDelay := 5
    end;
end;

end.
